package com.jcd.rpinjector;

import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;
//import android.widget.Toast;

//import com.topjohnwu.superuser.Shell;
import com.topjohnwu.superuser.io.SuFile;
import com.topjohnwu.superuser.io.SuFileInputStream;
import com.topjohnwu.superuser.io.SuFileOutputStream;
import com.topjohnwu.superuser.io.SuRandomAccessFile;

//import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
//import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
//import java.io.InputStreamReader;
import java.io.OutputStream;
/**import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;**/
import java.util.ArrayList;
/**import java.util.Arrays;
import java.util.List;**/
import java.util.Scanner;

public class MainActivity extends AppCompatActivity {
    public ArrayList<Long> Offsets = new ArrayList<>();
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        try {
            Process p = Runtime.getRuntime().exec("su");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        //ArrayList<Integer> Pids = findPid("com.sandboxol.indiegame.bedwar");
        //Long BaseLIB = findLibraryBase("libil2cpp.so",Pids);
        Patch("libBlockMan.so","C8 02 44 E3 1E FF 2F E1", 0xEF873C,"com.sandboxol.indiegame.bedwar");
    }
    public static int hex_b(String hex, byte[] out) {
        String trimmed = "";
        for (int i = 0; i < hex.length(); i++) {
            if (hex.charAt(i) != ' ')
                trimmed += hex.charAt(i);
        }
        for (int i = 0; i < trimmed.length() / 2; i++) {
            String substring = trimmed.substring(i * 2, i * 2 + 2);
            out[i] = (byte) Integer.parseInt(substring, 16);
        }
        return trimmed.length() / 2;
    }
    private void Patch(String lib,String hex,long offset,String process){
        SuRandomAccessFile suRaf;
        ArrayList<Integer> Pids = findPid(process);
        if (Offsets.isEmpty()){
            findLibraryBase(lib,Pids);
        }
        byte[] out = new byte[128];
        int length = hex_b(hex, out);
        for (Integer Pid : Pids) {
            for (long base : Offsets) {
                //Log.d("TRYHHH", "Normal addr : " + base +""+ Pid);
                //Log.d("TRYHHH","Added : " + (0x073E4 + offset));
                try {
                    suRaf = SuRandomAccessFile.open("/proc/" + Pid + "/mem", "rw");
                    suRaf.seek(base + offset);
                    suRaf.write(out);
                    suRaf.close();
                } catch (FileNotFoundException e) {
                    //Toast.makeText(this, "Failed to patch game", Toast.LENGTH_SHORT).show();
                } catch (IOException e) {
                    //Toast.makeText(this, "Failed to patch game", Toast.LENGTH_SHORT).show();
                }
            }
        }
    }

    public static void copy(String src, String dst) throws IOException {
        try (InputStream in = SuFileInputStream.open(src)) {
            try (OutputStream out = SuFileOutputStream.open(dst)) {
                // Transfer bytes from in to out
                byte[] buf = new byte[1024];
                int len;
                while ((len = in.read(buf)) > 0) {
                    out.write(buf, 0, len);
                }
            }
        }
    }

    public static void delete(String file){
        File fle = new File(file);
        fle.delete();
    }

    public void findLibraryBase(String lib,ArrayList<Integer> Pids){
        for (Integer Pid : Pids) {
            //Log.d("pid22",""+Pid);
            try {
                copy("/proc/" + Pid + "/maps",getFilesDir() + "maps.txt");
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
            try {
                Scanner scanner = new Scanner(new File(getFilesDir() + "maps.txt"));
                String line = "";
                while (scanner.hasNextLine()) {
                    line = scanner.nextLine();
                    String[] splitted = line.split("/");
                    Log.d("TRII1", line);
                    if(splitted.length > 7) {
                   //     Log.d("TRII3", "" + splitted[7]);
                        if (line.contains(lib)) {
                            Log.d("TRII0", "" + line);
                            Scanner scanner2 = new Scanner(line);
                            scanner2.useDelimiter("-| |\\n");
                            String startAddress = scanner2.next();
                            Log.d("TRII2", startAddress);
                            Offsets.add(Long.parseLong(startAddress, 16));
                        }
                    }
                }

                scanner.close();
                delete(getFilesDir() + "maps.txt");
            } catch (FileNotFoundException e) {
                throw new RuntimeException(e);
            }
        }
        //return Offsets;
    }

    public static ArrayList<Integer> findPid(String pname) {
        SuFile procDir = new SuFile("/proc/");
        SuFile[] procFiles = procDir.listFiles();
        ArrayList<Integer> pids = new ArrayList<>();
        if (procFiles == null) {
            //System.out.println("failed to open /proc");
            return pids;
        }
        for (SuFile procFile : procFiles) {
          //  Log.d("namez",procFile.getName());
            //String path = String.format("/proc/%s/cmdline", procFile.getName());
            //String cmdline = readFile(path);

            SuRandomAccessFile suRaf2;
            try {
                suRaf2 = SuRandomAccessFile.open("/proc/" + procFile.getName() + "/cmdline","r");
                String cmdline = suRaf2.readLine();
                if(cmdline != null){
                    if (cmdline.contains(pname)) {
                        int pid = Integer.parseInt(procFile.getName());
                   //     Log.d("DEV",""+pid);
                        pids.add(pid);
                    }
                }
            } catch (FileNotFoundException e) {

            } catch (IOException e) {

            }
        }
        return pids;
    }
}